// DirectIODlg.cpp : implementation file
//

#include "stdafx.h"
#include "DirectIO.h"
#include "DirectIODlg.h"
#include "DlgProxy.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDirectIODlg dialog

IMPLEMENT_DYNAMIC(CDirectIODlg, CDialog);

CDirectIODlg::CDirectIODlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDirectIODlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDirectIODlg)
	m_DigInputs = 0;
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	m_pAutoProxy = NULL;
}

CDirectIODlg::~CDirectIODlg()
{
	// If there is an automation proxy for this dialog, set
	//  its back pointer to this dialog to NULL, so it knows
	//  the dialog has been deleted.
	if (m_pAutoProxy != NULL)
		m_pAutoProxy->m_pDialog = NULL;
}

void CDirectIODlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDirectIODlg)
	DDX_Text(pDX, IDC_READING, m_DigInputs);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDirectIODlg, CDialog)
	//{{AFX_MSG_MAP(CDirectIODlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
	ON_BN_CLICKED(IDC_WRITE, OnWrite)
	ON_WM_CREATE()
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_WriteZero, OnWriteZero)
	ON_BN_CLICKED(IDC_READ, OnRead)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDirectIODlg message handlers

BOOL CDirectIODlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	//  see the code also in CDirectIODlg::OnCreate

	// open a session for board configured as Device 0 in the DLinx Config Panel
   	pdio->OpenDevice("kpciiso",0);
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDirectIODlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDirectIODlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDirectIODlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// Automation servers should not exit when a user closes the UI
//  if a controller still holds on to one of its objects.  These
//  message handlers make sure that if the proxy is still in use,
//  then the UI is hidden but the dialog remains around if it
//  is dismissed.

void CDirectIODlg::OnClose() 
{
    // close down our instance
	this->pdio->CloseDevice();

	if (CanExit())
		CDialog::OnClose();
}

void CDirectIODlg::OnOK() 
{
	if (CanExit())
		CDialog::OnOK();
}

void CDirectIODlg::OnCancel() 
{
	if (CanExit())
		CDialog::OnCancel();
}

BOOL CDirectIODlg::CanExit()
{
	// If the proxy object is still around, then the automation
	//  controller is still holding on to this application.  Leave
	//  the dialog around, but hide its UI.
	if (m_pAutoProxy != NULL)
	{
		ShowWindow(SW_HIDE);
		return FALSE;
	}

	return TRUE;
}



int CDirectIODlg::OnCreate(LPCREATESTRUCT lpCreateStruct) 
{
	if (CDialog::OnCreate(lpCreateStruct) == -1)
		return -1;
	
try 
	{
		// The following smart pointer declaration will create
		// an instance of the object.
        KDIGIOLib::IKDigitalIoPtr m_pdio(__uuidof(KDIGIOLib::KDigitalIo) );
		this->pdio = m_pdio;  // set m_pdio equal to our global variable, pdio
	}
	catch (const _com_error& Err) 
	{
		TRACE( "Error Creating Instance:\nError number is 0x%08X\nError message is %s\n", Err.Error( ), Err.ErrorMessage( ) );
		// Display error description if rich error info supported
		if ( Err.ErrorInfo( ) )
		TRACE( "%s\n\n", Err.Description( ) );
	}
	
	return 0;
	
}

void CDirectIODlg::OnDestroy() 
{
	CDialog::OnDestroy();
}

void CDirectIODlg::OnWriteZero() 
{
	this->pdio->Write(4,0x0);  // clear bit 0, IP0
}

void CDirectIODlg::OnWrite() 
{
	// the 8 relays (digital outputs) are at an offset of 4
	//
	// legal value to write would be value of 0 to 255

	this->pdio->Write(4,0x1);  // set bit 0, IP0
	
}

void CDirectIODlg::OnRead() 
{
  m_DigInputs = this->pdio->Read(0);
  UpdateData(FALSE);  // display the value on the dialog
	
}
